NB: drake has been superseded by [targets](https://books.ropensci.org/targets/) - more soon

# drake:

 * use [drake](https://docs.ropensci.org/drake/) to massively speed up and [manage your workflow](https://milesmcbain.xyz/the-drake-post/). This includes always:
    * loading and processing all your data inside a drake plan in a .R file. _So it only gets re-run if the code or data changes_
    * creating each of your output objects inside the drake plan. _So they only get re-created if the code or data changes_
    * rendering your .Rmd report at the end of the drake plan. _So you can pass the params in and report the output objects_
    * => the first time you run the plan it will build everything. The second time, e.g. after you fix a .Rmd typo, _only the bits that have changed get re-built_. **Warning: drake can reduce the time it takes to run your code by an order of magnitude. This could seriously damage your tea & cake in-take...**
 
We have an example of [using drake](https://git.soton.ac.uk/SERG/workflow/-/blob/master/Rmd/make_basicReport.R)