# How to use the UoS Iridis HPC

HPC = [High Performance Computer](https://www.southampton.ac.uk/isolutions/staff/iridis.page). Lots of memory, lots of processors, good if you can parallelise your code. Can you?

## Which Iridis?

We have:

 * _Iridis 4: https://hpc.soton.ac.uk/redmine/projects/iridis-4-support/wiki (**retiring February 2022**)_
 * Iridis 5: https://hpc.soton.ac.uk/redmine/projects/iridis-5-support/wiki

5 is newer, bigger & better etc etc but new projects start on 4 (_before February 2022_) and, presumably when you prove you need 5, you can transfer.

## How to access
Fill in the form on the [iridis page](https://www.southampton.ac.uk/isolutions/staff/iridis.page).

## How to login

OK, so you are going to need to [get a bit friendly with unix](https://www.dummies.com/computers/operating-systems/unix/) because the Iridis service runs unix (linux). In general you will be interacting with it using a command line tool like terminal/console etc. Back to the good old days. 

Assuming you want iridis 5 to start with you can login to any of:

 * iridis5_a.soton.ac.uk
 * iridis5_b.soton.ac.uk
 * iridis5_c.soton.ac.uk

To do this:

 * make sure you are running the UoS vpn
 * open a terminal/console window on your desktop
 * type `ssh YourUsername@iridis5_a.soton.ac.uk` (or which ever you want) & hit return. YourUsername = your UoS username obvs
 * type `yes` to the fingerprint question (DO NOT PANIC!). This should only happen the first time you do this
 * type your UoS password & hit return
 * you're in!

## Now what?

Read these first! 

 * https://hpc.soton.ac.uk/redmine/projects/iridis-5-support/wiki/New_User_Warnings <- **especially this one!**
 * https://hpc.soton.ac.uk/redmine/projects/iridis-5-support/wiki/Getting_started

## R

https://hpc.soton.ac.uk/redmine/projects/iridis-5-support/wiki/R

After you've [loaded the R module](https://hpc.soton.ac.uk/redmine/projects/iridis-5-support/wiki/R), you can interactively run R scripts by running R. Or you can run them non-interactively using the `Rscript <yourScript.R>` command. But you probably shouldn't. 

Instead you should submit your commands (e.g. `Rscript myScript.R`) to the Iridis scheduling system so it can balance everyone's needs. You need to [learn how to do this](https://hpc.soton.ac.uk/redmine/projects/iridis-5-support/wiki/Job_Submission)...

## How to get your code on Iridis

If you've set up a repo on git.soton it's easy - Iridis has git installed. You will have to use git at the command line but it's [not so bad](https://docs.gitlab.com/ee/gitlab-basics/start-using-git.html)...

If you haven't then do so.

## Where to put your data

Sadly Iridis cannot see `J:\ or \\soton.ac.uk\resource\` so you you can't follow [usual advice](https://git.soton.ac.uk/SERG/workflow/-/blob/master/howTo/keepingData.md). You will need to copy the data you need to your home directory on Iridis. Do this using sftp - [CyberDuck](https://cyberduck.io/) works well on OSX, no doubt there are others for [Windoze](https://hpc.soton.ac.uk/redmine/projects/iridis-4-support/wiki/Transferring_files_to_and_from_Iridis_4).

If you [run out of space](https://hpc.soton.ac.uk/redmine/projects/iridis-4-support/wiki/User_account_information_and_limits) in your home folder/directory (100 GB max) you can also put it in a scratch folder which will take 1 TB. But this is not backed-up - so data in there is at risk.

## Adding packages

Yes [you can do this](https://hpc.soton.ac.uk/redmine/projects/iridis-4-support/wiki/R#Installing-R-packages-locally). It's just a bit more involved than doing it in RStudio because you have to use the R command line.

## What you cannot do

Run RStudio. Well OK, you can. But it needs the ssh tunneling and XWindow thing mentioned above. Yeahnah.

## The wish list

 * Iridis supports RStudio Server - so you can login via a web UI
 * Iridis can see `J:\ or \\soton.ac.uk\resource\` so all roads lead to the same data
