# Other 'How to' resources:

 * excellent [guidance for collaborative project teams (especially team leads)](https://opensource.guide/) even if they're not open and not R
 * [What they forgot to teach you](https://rstats.wtf/) about R including some required reading:
    * why you should use here::here() and **not setwd()** to make sure your code works _anywhere_
    * why you should use (RStudio) p/Projects to _manage your code_
    * [how you should name things](https://speakerdeck.com/jennybc/how-to-name-files) to _stay sane_
    * why you should not add anything to .Renviron or Rprofile unless you want to _irritate team members_
    * and much more, although:
        *  we don't agree with [keeping your data in your project](https://rstats.wtf/project-oriented-workflow.html#work-in-a-project). Data should be [somewhere else](keepingData.md), _unless you're a .gitignore wizard_ and your data is small (and non-sensitive/non-commercial/public etc)
 * using [git(hub/lab)](https://happygitwithr.com/) for version control (perhaps via [usethis](https://usethis.r-lib.org/) and knowing about [ohshitgit](https://ohshitgit.com/) just in case)
 * using git forks and [branches](https://git-scm.com/book/en/v2/Git-Branching-Branches-in-a-Nutshell) as a way for different people to work on the same project without clashing 
    * Tom has written a [setup guide](https://git.soton.ac.uk/SERG/feeg6025support/feeg6025-2020-2021/-/blob/master/Guides/SETUP.md) for getting started
    * we have written a [short guide](gitBranches.md)
    * [HappyGit](https://happygitwithr.com/fork-and-clone.html) gives you the details
    * [ohshitgit](https://ohshitgit.com/) may be required here too (but not if you've followed the instructions above)
 * using [git(hub/lab) issues](https://guides.github.com/features/issues/) as a way to manage your project - just like we did for the [new ECCD website](https://git.soton.ac.uk/SERG/sergwebsite/-/issues)
 
Even more ...

 * on [naming files (tidyverse)](https://style.tidyverse.org/files.html)
 * coding style, syntax etc. with [lintr](https://github.com/jimhester/lintr)
 * set up projects as packages with help from [usethis](https://usethis.r-lib.org/)
 * tools for reproducibility
    * Is your project file reproducible? [fertile](https://github.com/baumer-lab/fertile) might help
    * Or try [rrrpkg](https://github.com/ropensci/rrrpkg) to create a research compendium
    
