# make file for drake
# see https://books.ropensci.org/drake/projects.html#usage

# Set up ----
startTime <- proc.time()

# use r_make to run the plan inside a clean R session so nothing gets contaminated
drake::r_make(source = "_drake_basicReport.R") # where we keep the drake plan etc

# we don't keep this in /R because that's where the package functions live
# we don't use "_drake.R" because we have lots of different plans

# Finish off ----

t <- proc.time() - startTime # how long did it take?
elapsed <- t[[3]]

print("Done")
print(paste0("Completed in ", round(elapsed/60,3), " minutes using ",
             R.version.string, " running on ", R.version$platform))